com.fasterxml.jackson.databind

## Class AnnotationIntrospector

- java.lang.Object
- - com.fasterxml.jackson.databind.AnnotationIntrospector

All Implemented Interfaces:
  com.fasterxml.jackson.core.Versioned, Serializable

Direct Known Subclasses:
  AnnotationIntrospectorPair, JacksonAnnotationIntrospector, NopAnnotationIntrospector

    public abstract class AnnotationIntrospector
    extends Object
    implements com.fasterxml.jackson.core.Versioned, Serializable

Abstract class that defines API used for introspecting annotation-based configuration for serialization and deserialization. Separated so that different sets of annotations can be supported, and support plugged-in dynamically.

Although default implementations are based on using annotations as the only (or at least main) information source, custom implementations are not limited in such a way, and in fact there is no expectation they should be. So the name is bit of misnomer; this is a general configuration introspection facility.

NOTE: due to rapid addition of new methods (and changes to existing methods), it is strongly recommended that custom implementations should not directly extend this class, but rather extend `NopAnnotationIntrospector`. This way added methods will not break backwards compatibility of custom annotation introspectors.

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `AnnotationIntrospector.ReferenceProperty` Value type used with managed and back references; contains type and logic name, used to link related references
`static interface` `AnnotationIntrospector.XmlExtensions` Add-on extension used for XML-specific configuration, needed to decouple format module functionality from pluggable introspection functionality (especially JAXB-annotation related one).

### Constructor Summary

Constructors
Constructor and Description
`AnnotationIntrospector()`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
`protected <A extends Annotation> A` `_findAnnotation(Annotated ann, Class<A> annoClass)` Method that should be used by sub-classes for ALL annotation access; overridable so that sub-classes may, if they choose to, mangle actual access to block access ("hide" annotations) or perhaps change it.
`protected boolean` `_hasAnnotation(Annotated ann, Class<? extends Annotation> annoClass)` Method that should be used by sub-classes for ALL annotation existence access; overridable so that sub-classes may, if they choose to, mangle actual access to block access ("hide" annotations) or perhaps change value seen.
`protected boolean` `_hasOneOf(Annotated ann, Class<? extends Annotation>[] annoClasses)` Alternative lookup method that is used to see if annotation has at least one of annotations of types listed in second argument.
`Collection<AnnotationIntrospector>` `allIntrospectors()` Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container.
`Collection<AnnotationIntrospector>` `allIntrospectors(Collection<AnnotationIntrospector> result)` Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container.
`void` `findAndAddVirtualProperties(MapperConfig<?> config, AnnotatedClass ac, List<BeanPropertyWriter> properties)` Method for adding possible virtual properties to be serialized along with regular properties.
`VisibilityChecker<?>` `findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)` Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors).
`String` `findClassDescription(AnnotatedClass ac)` Method used to check whether specified class defines a human-readable description to use for documentation.
`Object` `findContentDeserializer(Annotated am)` Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property.
`Object` `findContentSerializer(Annotated am)` Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property.
`com.fasterxml.jackson.annotation.JsonCreator.Mode` `findCreatorAnnotation(MapperConfig<?> config, Annotated ann)` Method called to check whether potential Creator (constructor or static factory method) has explicit annotation to indicate it as actual Creator; and if so, which `JsonCreator.Mode` to use.
`com.fasterxml.jackson.annotation.JsonCreator.Mode` `findCreatorBinding(Annotated ann)` Deprecated. Since 2.9 use `findCreatorAnnotation(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead.
`Enum<?>` `findDefaultEnumValue(AnnotatedClass ac, Enum<?>[] enumValues)` Finds the first Enum value that should be considered as default value for unknown Enum values, if present.
`Enum<?>` `findDefaultEnumValue(Class<Enum<?>> enumCls)` Deprecated. Since 2.16. Use `findDefaultEnumValue(AnnotatedClass, Enum[])` instead.
`Object` `findDeserializationContentConverter(AnnotatedMember a)` Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).
`Object` `findDeserializationConverter(Annotated a)` Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of deserialization.
`Object` `findDeserializer(Annotated am)` Method for getting a deserializer definition on specified method or field.
`void` `findEnumAliases(Class<?> enumType, Enum<?>[] enumValues, String[][] aliases)` Deprecated. Since 2.16
`void` `findEnumAliases(MapperConfig<?> config, AnnotatedClass annotatedClass, Enum<?>[] enumValues, String[][] aliases)` Method that is called to check if there are alternative names (aliases) that can be accepted for entries in addition to primary names that were introspected earlier, related to `findEnumValues(java.lang.Class<?>, java.lang.Enum<?>[], java.lang.String[])`.
`Object` `findEnumNamingStrategy(MapperConfig<?> config, AnnotatedClass ac)` Method for finding `EnumNamingStrategy` for given class, if any specified by annotations; and if so, either return a `EnumNamingStrategy` instance, or Class to use for creating instance
`String` `findEnumValue(Enum<?> value)` Deprecated. Since 2.8: use `findEnumValues(java.lang.Class<?>, java.lang.Enum<?>[], java.lang.String[])` instead because this method does not properly handle override settings (defaults to `enum.name` without indicating whether that is explicit or not), and is inefficient to call one-by-one.
`String[]` `findEnumValues(Class<?> enumType, Enum<?>[] enumValues, String[] names)` Deprecated. Since 2.16
`String[]` `findEnumValues(MapperConfig<?> config, AnnotatedClass annotatedClass, Enum<?>[] enumValues, String[] names)` Finds the explicitly defined name of the given set of `Enum` values, if any.
`Object` `findFilterId(Annotated ann)` Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.
`com.fasterxml.jackson.annotation.JsonFormat.Value` `findFormat(Annotated memberOrClass)` Method for finding format annotations for property or class.
`Boolean` `findIgnoreUnknownProperties(AnnotatedClass ac)` Deprecated. Since 2.8, use `findPropertyIgnoralByName(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead
`String` `findImplicitPropertyName(AnnotatedMember member)` Method for finding implicit name for a property that given annotated member (field, method, creator parameter) may represent.
`com.fasterxml.jackson.annotation.JacksonInject.Value` `findInjectableValue(AnnotatedMember m)` Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection.
`Object` `findInjectableValueId(AnnotatedMember m)` Deprecated. Since 2.9 Use `findInjectableValue(com.fasterxml.jackson.databind.introspect.AnnotatedMember)` instead
`Object` `findKeyDeserializer(Annotated am)` Method for getting a deserializer definition for keys of associated `Map` property.
`Object` `findKeySerializer(Annotated am)` Method for getting a serializer definition for keys of associated `java.util.Map` property.
`Boolean` `findMergeInfo(Annotated ann)` Method for finding merge settings for property, if any.
`PropertyName` `findNameForDeserialization(Annotated ann)` Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for deserialization (reading JSON into POJOs).
`PropertyName` `findNameForSerialization(Annotated a)` Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for serialization.
`Object` `findNamingStrategy(AnnotatedClass ac)` Method for finding `PropertyNamingStrategy` for given class, if any specified by annotations; and if so, either return a `PropertyNamingStrategy` instance, or Class to use for creating instance
`Object` `findNullSerializer(Annotated am)` Method for getting a serializer definition for serializer to use for nulls (null values) of associated property or type.
`ObjectIdInfo` `findObjectIdInfo(Annotated ann)` Method for checking whether given annotated thing (type, or accessor) indicates that values referenced (values of type of annotated class, or values referenced by annotated property; latter having precedence) should include Object Identifier, and if so, specify details of Object Identity used.
`ObjectIdInfo` `findObjectReferenceInfo(Annotated ann, ObjectIdInfo objectIdInfo)` Method for figuring out additional properties of an Object Identity reference
`Class<?>` `findPOJOBuilder(AnnotatedClass ac)` Method for finding Builder object to use for constructing value instance and binding data (sort of combining value instantiators that can construct, and deserializers that can bind data).
`JsonPOJOBuilder.Value` `findPOJOBuilderConfig(AnnotatedClass ac)`
`com.fasterxml.jackson.annotation.JsonTypeInfo.Value` `findPolymorphicTypeInfo(MapperConfig<?> config, Annotated ann)` Method for checking whether given Class or Property Accessor specifies polymorphic type-handling information, to indicate need for polymorphic handling.
`String[]` `findPropertiesToIgnore(Annotated ac, boolean forSerialization)` Deprecated. Since 2.8, use `findPropertyIgnoralByName(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead
`com.fasterxml.jackson.annotation.JsonProperty.Access` `findPropertyAccess(Annotated ann)` Method for finding optional access definition for a property, annotated on one of its accessors.
`List<PropertyName>` `findPropertyAliases(Annotated ann)` Method called to find if given property has alias(es) defined.
`TypeResolverBuilder<?>` `findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType containerType)` Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values.
`String` `findPropertyDefaultValue(Annotated ann)` Method for finding suggested default value (as simple textual serialization) for the property.
`String` `findPropertyDescription(Annotated ann)` Method used to check whether specified property member (accessor or mutator) defines human-readable description to use for documentation.
`com.fasterxml.jackson.annotation.JsonIgnoreProperties.Value` `findPropertyIgnoralByName(MapperConfig<?> config, Annotated ann)` Method for finding information about properties to ignore either by name, or by more general specification ("ignore all unknown").
`com.fasterxml.jackson.annotation.JsonIgnoreProperties.Value` `findPropertyIgnorals(Annotated ac)` Deprecated. 2.12, use `findPropertyIgnoralByName(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead.
`com.fasterxml.jackson.annotation.JsonInclude.Value` `findPropertyInclusion(Annotated a)` Method for checking inclusion criteria for a type (Class) or property (yes, method name is bit unfortunate -- not just for properties!).
`com.fasterxml.jackson.annotation.JsonIncludeProperties.Value` `findPropertyInclusionByName(MapperConfig<?> config, Annotated ann)` Method for finding information about names of properties to included.
`Integer` `findPropertyIndex(Annotated ann)` Method used to check whether specified property member (accessor or mutator) defines numeric index, and if so, what is the index value.
`TypeResolverBuilder<?>` `findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)` Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances.
`AnnotationIntrospector.ReferenceProperty` `findReferenceType(AnnotatedMember member)` Method for checking if given member indicates that it is part of a reference (parent/child).
`PropertyName` `findRenameByField(MapperConfig<?> config, AnnotatedField f, PropertyName implName)` Method called on fields that are eligible candidates for properties (that is, non-static member fields), but not necessarily selected (may or may not be visible), to let fields affect name linking.
`PropertyName` `findRootName(AnnotatedClass ac)` Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined.
`Object` `findSerializationContentConverter(AnnotatedMember a)` Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).
`Object` `findSerializationConverter(Annotated a)` Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of serialization.
`String[]` `findSerializationPropertyOrder(AnnotatedClass ac)` Method for accessing defined property serialization order (which may be partial).
`Boolean` `findSerializationSortAlphabetically(Annotated ann)` Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
`JsonSerialize.Typing` `findSerializationTyping(Annotated a)` Method for accessing declared typing mode annotated (if any).
`Object` `findSerializer(Annotated am)` Method for getting a serializer definition on specified method or field.
`com.fasterxml.jackson.annotation.JsonSetter.Value` `findSetterInfo(Annotated ann)` Method for finding possible settings for property, given annotations on an accessor.
`List<NamedType>` `findSubtypes(Annotated a)` Method for locating annotation-specified subtypes related to annotated entity (class, method, field).
`String` `findTypeName(AnnotatedClass ac)` Method for checking if specified type has explicit name.
`TypeResolverBuilder<?>` `findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)` Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances.
`NameTransformer` `findUnwrappingNameTransformer(AnnotatedMember member)` Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e.
`Object` `findValueInstantiator(AnnotatedClass ac)` Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.
`Class<?>[]` `findViews(Annotated a)` Method for checking if annotated property (represented by a field or getter/setter method) has definitions for views it is to be included in.
`PropertyName` `findWrapperName(Annotated ann)` Method used to check if specified property has annotation that indicates that it should be wrapped in an element; and if so, name to use.
`Boolean` `hasAnyGetter(Annotated ann)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.
`boolean` `hasAnyGetterAnnotation(AnnotatedMethod am)` Deprecated. Since 2.9 Use `hasAnyGetter(com.fasterxml.jackson.databind.introspect.Annotated)` instead
`Boolean` `hasAnySetter(Annotated ann)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
`boolean` `hasAnySetterAnnotation(AnnotatedMethod am)` Deprecated. Since 2.9 use `hasAnySetter(com.fasterxml.jackson.databind.introspect.Annotated)` instead.
`Boolean` `hasAsKey(MapperConfig<?> config, Annotated a)` Method for checking whether given method has an annotation that suggests the return value of annotated field or method should be used as "the key" of the object instance; usually serialized as a primitive value such as String or number.
`Boolean` `hasAsValue(Annotated a)` Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
`boolean` `hasAsValueAnnotation(AnnotatedMethod am)` Deprecated. Since 2.9 Use `hasAsValue(Annotated)` instead.
`boolean` `hasCreatorAnnotation(Annotated ann)` Deprecated. Since 2.9 use `findCreatorAnnotation(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead.
`boolean` `hasIgnoreMarker(AnnotatedMember m)` Method called to check whether given property is marked to be ignored.
`Boolean` `hasRequiredMarker(AnnotatedMember m)` Method that can be called to check whether this member has an annotation that suggests whether value for matching property is required or not.
`boolean` `isAnnotationBundle(Annotation ann)` Method for checking whether given annotation is considered an annotation bundle: if so, all meta-annotations it has will be used instead of annotation ("bundle") itself.
`Boolean` `isIgnorableType(AnnotatedClass ac)` Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
`Boolean` `isTypeId(AnnotatedMember am)` Method for checking whether given accessor claims to represent type id: if so, its value may be used as an override, instead of generated type id.
`static AnnotationIntrospector` `nopInstance()` Factory method for accessing "no operation" implementation of introspector: instance that will never find any annotation-based configuration.
`static AnnotationIntrospector` `pair(AnnotationIntrospector a1, AnnotationIntrospector a2)`
`JavaType` `refineDeserializationType(MapperConfig<?> config, Annotated a, JavaType baseType)` Method called to find out possible type refinements to use for deserialization.
`JavaType` `refineSerializationType(MapperConfig<?> config, Annotated a, JavaType baseType)` Method called to find out possible type refinements to use for deserialization, including not just value itself but key and/or content type, if type has those.
`AnnotatedMethod` `resolveSetterConflict(MapperConfig<?> config, AnnotatedMethod setter1, AnnotatedMethod setter2)` Method called in cases where a class has two methods eligible to be used for the same logical property, and default logic is not enough to figure out clear precedence.
`abstract com.fasterxml.jackson.core.Version` `version()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AnnotationIntrospector

    public AnnotationIntrospector()

### Method Detail

#### nopInstance

    public static AnnotationIntrospector nopInstance()

Factory method for accessing "no operation" implementation of introspector: instance that will never find any annotation-based configuration.

Returns:
  "no operation" instance

#### pair

    public static AnnotationIntrospector pair(AnnotationIntrospector a1,
                                              AnnotationIntrospector a2)

#### allIntrospectors

    public Collection<AnnotationIntrospector> allIntrospectors()

Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container. Used to get access to all container introspectors in their priority order.

Default implementation returns a Singleton list with this introspector as contents. This usually works for sub-classes, except for proxy or delegating "container introspectors" which need to override implementation.

Returns:
  Collection of all introspectors starting with this one, in case multiple introspectors are chained

#### allIntrospectors

    public Collection<AnnotationIntrospector> allIntrospectors(Collection<AnnotationIntrospector> result)

Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container. Used to get access to all container introspectors in their priority order.

Default implementation adds this introspector in result; this usually works for sub-classes, except for proxy or delegating "container introspectors" which need to override implementation.

Parameters:
  `result` - Container to add introspectors to
Returns:
  Passed in `Collection` filled with introspectors as explained above

#### version

    public abstract com.fasterxml.jackson.core.Version version()

Specified by:
  `version` in interface `com.fasterxml.jackson.core.Versioned`

#### isAnnotationBundle

    public boolean isAnnotationBundle(Annotation ann)

Method for checking whether given annotation is considered an annotation bundle: if so, all meta-annotations it has will be used instead of annotation ("bundle") itself.

Parameters:
  `ann` - Annotated entity to introspect
Returns:
  True if given annotation is considered an annotation bundle; false if not

#### findObjectIdInfo

    public ObjectIdInfo findObjectIdInfo(Annotated ann)

Method for checking whether given annotated thing (type, or accessor) indicates that values referenced (values of type of annotated class, or values referenced by annotated property; latter having precedence) should include Object Identifier, and if so, specify details of Object Identity used.

Parameters:
  `ann` - Annotated entity to introspect
Returns:
  Details of Object Id as explained above, if Object Id handling to be applied; `null` otherwise.

#### findObjectReferenceInfo

    public ObjectIdInfo findObjectReferenceInfo(Annotated ann,
                                                ObjectIdInfo objectIdInfo)

Method for figuring out additional properties of an Object Identity reference

Parameters:
  `ann` - Annotated entity to introspect
  `objectIdInfo` - (optional) Base Object Id information, if any; `null` if none
Returns:
  `ObjectIdInfo` augmented with possible additional information
Since:
  2.1

#### findRootName

    public PropertyName findRootName(AnnotatedClass ac)

Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined. Returns null if no declaration found; can return explicit empty String, which is usually ignored as well as null.

NOTE: method signature changed in 2.1, to return `PropertyName` instead of String.

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Root name to use, if any; `null` if not

#### isIgnorableType

    public Boolean isIgnorableType(AnnotatedClass ac)

Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Boolean.TRUE if properties of type should be ignored; Boolean.FALSE if they are not to be ignored, null for default handling (which is 'do not ignore')

#### findPropertyIgnoralByName

    public com.fasterxml.jackson.annotation.JsonIgnoreProperties.Value findPropertyIgnoralByName(MapperConfig<?> config,
                                                                                                 Annotated ann)

Method for finding information about properties to ignore either by name, or by more general specification ("ignore all unknown"). This method combines multiple aspects of ignorals and deprecates earlier methods such as `findPropertiesToIgnore(Annotated, boolean)` and `findIgnoreUnknownProperties(AnnotatedClass)`.

Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `ann` - Annotated entity (Class, Accessor) to introspect
Returns:
  Property ignoral settings to use; `JsonIgnoreProperties.Value.empty()` for defaults (should not return `null`)
Since:
  2.12 (to replace `findPropertyIgnorals()`)

#### findPropertyInclusionByName

    public com.fasterxml.jackson.annotation.JsonIncludeProperties.Value findPropertyInclusionByName(MapperConfig<?> config,
                                                                                                    Annotated ann)

Method for finding information about names of properties to included. This is typically used to strictly limit properties to include based on fully defined set of names ("allow-listing"), as opposed to excluding potential properties by exclusion ("deny-listing").

Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `ann` - Annotated entity (Class, Accessor) to introspect
Returns:
  Property inclusion settings to use; `JsonIncludeProperties.Value.all()` for defaults (should not return `null`)
Since:
  2.12

#### findFilterId

    public Object findFilterId(Annotated ann)

Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.

Parameters:
  `ann` - Annotated entity to introspect
Returns:
  Id of the filter to use for filtering properties of annotated class, if any; or null if none found.

#### findNamingStrategy

    public Object findNamingStrategy(AnnotatedClass ac)

Method for finding `PropertyNamingStrategy` for given class, if any specified by annotations; and if so, either return a `PropertyNamingStrategy` instance, or Class to use for creating instance

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Sub-class or instance of `PropertyNamingStrategy`, if one is specified for given class; null if not.
Since:
  2.1

#### findEnumNamingStrategy

    public Object findEnumNamingStrategy(MapperConfig<?> config,
                                         AnnotatedClass ac)

Method for finding `EnumNamingStrategy` for given class, if any specified by annotations; and if so, either return a `EnumNamingStrategy` instance, or Class to use for creating instance

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Subclass or instance of `EnumNamingStrategy`, if one is specified for given class; null if not.
Since:
  2.15

#### findClassDescription

    public String findClassDescription(AnnotatedClass ac)

Method used to check whether specified class defines a human-readable description to use for documentation. There are no further definitions for contents; for example, whether these may be marked up using HTML (or something like wiki format like Markup) is not defined.

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Human-readable description, if any.
Since:
  2.7

#### findPropertiesToIgnore

    @Deprecated
    public String[] findPropertiesToIgnore(Annotated ac,
                                                       boolean forSerialization)

Deprecated. Since 2.8, use `findPropertyIgnoralByName(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead

Parameters:
  `forSerialization` - True if requesting properties to ignore for serialization; false if for deserialization
  `ac` - Annotated class to introspect
Returns:
  Array of names of properties to ignore
Since:
  2.6

#### findIgnoreUnknownProperties

    @Deprecated
    public Boolean findIgnoreUnknownProperties(AnnotatedClass ac)

Deprecated. Since 2.8, use `findPropertyIgnoralByName(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead
Method for checking whether an annotation indicates that all unknown properties should be ignored.

Parameters:
  `ac` - Annotated class to introspect
Returns:
  True if class has something indicating "ignore [all] unknown properties"

#### findPropertyIgnorals

    @Deprecated
    public com.fasterxml.jackson.annotation.JsonIgnoreProperties.Value findPropertyIgnorals(Annotated ac)

Deprecated. 2.12, use `findPropertyIgnoralByName(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead.

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Property ignoral settings to use; `JsonIgnoreProperties.Value.empty()` for defaults (should not return `null`)
Since:
  2.8

#### findAutoDetectVisibility

    public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac,
                                                         VisibilityChecker<?> checker)

Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors). A baseline checker is given, and introspector is to either return it as is (if no annotations are found), or build and return a derived instance (using checker's build methods).

Parameters:
  `ac` - Annotated class to introspect
  `checker` - Default visibility settings in effect before any override
Returns:
  Visibility settings after possible annotation-based overrides

#### findPolymorphicTypeInfo

    public com.fasterxml.jackson.annotation.JsonTypeInfo.Value findPolymorphicTypeInfo(MapperConfig<?> config,
                                                                                       Annotated ann)

Method for checking whether given Class or Property Accessor specifies polymorphic type-handling information, to indicate need for polymorphic handling.

Parameters:
  `config` - Effective mapper configuration in use
  `ann` - Annotated entity to introspect
Since:
  2.16 (backported from Jackson 3.0)

#### findTypeResolver

    public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config,
                                                   AnnotatedClass ac,
                                                   JavaType baseType)

Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `ac` - Annotated class to check for annotations
  `baseType` - Base java type of value for which resolver is to be found
Returns:
  Type resolver builder for given type, if one found; null if none

#### findPropertyTypeResolver

    public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config,
                                                           AnnotatedMember am,
                                                           JavaType baseType)

Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `am` - Annotated member (field or method) to check for annotations
  `baseType` - Base java type of property for which resolver is to be found
Returns:
  Type resolver builder for properties of given entity, if one found; null if none

#### findPropertyContentTypeResolver

    public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config,
                                                                  AnnotatedMember am,
                                                                  JavaType containerType)

Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `am` - Annotated member (field or method) to check for annotations
  `containerType` - Type of property for which resolver is to be found (must be a container type)
Returns:
  Type resolver builder for values contained in properties of given entity, if one found; null if none

#### findSubtypes

    public List<NamedType> findSubtypes(Annotated a)

Method for locating annotation-specified subtypes related to annotated entity (class, method, field). Note that this is only guaranteed to be a list of directly declared subtypes, no recursive processing is guarantees (i.e. caller has to do it if/as necessary)

Parameters:
  `a` - Annotated entity (class, field/method) to check for annotations
Returns:
  List of subtype definitions found if any; `null` if none

#### findTypeName

    public String findTypeName(AnnotatedClass ac)

Method for checking if specified type has explicit name.

Parameters:
  `ac` - Class to check for type name annotations
Returns:
  Explicit type name (aka Type Id) found, if any; `null` if none

#### isTypeId

    public Boolean isTypeId(AnnotatedMember am)

Method for checking whether given accessor claims to represent type id: if so, its value may be used as an override, instead of generated type id.

Parameters:
  `am` - Annotated accessor (field/method/constructor parameter) to check for annotations
Returns:
  Boolean to indicate whether member is a type id or not, if annotation found; `null` if no information found.

#### findReferenceType

    public AnnotationIntrospector.ReferenceProperty findReferenceType(AnnotatedMember member)

Method for checking if given member indicates that it is part of a reference (parent/child).

#### findUnwrappingNameTransformer

    public NameTransformer findUnwrappingNameTransformer(AnnotatedMember member)

Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e. expect unwrapped representation during deserialization). Return value is the name transformation to use, if wrapping/unwrapping should be done, or null if not -- note that transformation may simply be identity transformation (no changes).

#### hasIgnoreMarker

    public boolean hasIgnoreMarker(AnnotatedMember m)

Method called to check whether given property is marked to be ignored. This is used to determine whether to ignore properties, on per-property basis, usually combining annotations from multiple accessors (getters, setters, fields, constructor parameters).

#### findInjectableValue

    public com.fasterxml.jackson.annotation.JacksonInject.Value findInjectableValue(AnnotatedMember m)

Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection. Type if identifier needs to be compatible with provider of values (of type `InjectableValues`); often a simple String id is used.

Parameters:
  `m` - Member to check
Returns:
  Identifier of value to inject, if any; null if no injection indicator is found
Since:
  2.9

#### hasRequiredMarker

    public Boolean hasRequiredMarker(AnnotatedMember m)

Method that can be called to check whether this member has an annotation that suggests whether value for matching property is required or not.

#### findViews

    public Class<?>[] findViews(Annotated a)

Method for checking if annotated property (represented by a field or getter/setter method) has definitions for views it is to be included in. If null is returned, no view definitions exist and property is always included (or always excluded as per default view inclusion configuration); otherwise it will only be included for views included in returned array. View matches are checked using class inheritance rules (sub-classes inherit inclusions of super-classes)

Since 2.9 this method may also be called to find "default view(s)" for `AnnotatedClass`

Parameters:
  `a` - Annotated property (represented by a method, field or ctor parameter)
Returns:
  Array of views (represented by classes) that the property is included in; if null, always included (same as returning array containing `Object.class`)

#### findFormat

    public com.fasterxml.jackson.annotation.JsonFormat.Value findFormat(Annotated memberOrClass)

Method for finding format annotations for property or class. Return value is typically used by serializers and/or deserializers to customize presentation aspects of the serialized value.

Since:
  2.1

#### findWrapperName

    public PropertyName findWrapperName(Annotated ann)

Method used to check if specified property has annotation that indicates that it should be wrapped in an element; and if so, name to use. Note that not all serializers and deserializers support use this method: currently (2.1) it is only used by XML-backed handlers.

Returns:
  Wrapper name to use, if any, or `PropertyName.USE_DEFAULT` to indicate that no wrapper element should be used.
Since:
  2.1

#### findPropertyDefaultValue

    public String findPropertyDefaultValue(Annotated ann)

Method for finding suggested default value (as simple textual serialization) for the property. While core databind does not make any use of it, it is exposed for extension modules to use: an expected use is generation of schema representations and documentation.

Since:
  2.5

#### findPropertyDescription

    public String findPropertyDescription(Annotated ann)

Method used to check whether specified property member (accessor or mutator) defines human-readable description to use for documentation. There are no further definitions for contents; for example, whether these may be marked up using HTML is not defined.

Returns:
  Human-readable description, if any.
Since:
  2.3

#### findPropertyIndex

    public Integer findPropertyIndex(Annotated ann)

Method used to check whether specified property member (accessor or mutator) defines numeric index, and if so, what is the index value. Possible use cases for index values included use by underlying data format (some binary formats mandate use of index instead of name) and ordering of properties (for documentation, or during serialization).

Returns:
  Explicitly specified index for the property, if any
Since:
  2.4

#### findImplicitPropertyName

    public String findImplicitPropertyName(AnnotatedMember member)

Method for finding implicit name for a property that given annotated member (field, method, creator parameter) may represent. This is different from explicit, annotation-based property name, in that it is "weak" and does not either proof that a property exists (for example, if visibility is not high enough), or override explicit names. In practice this method is used to introspect optional names for creator parameters (which may or may not be available and cannot be detected by standard databind); or to provide alternate name mangling for fields, getters and/or setters.

Since:
  2.4

#### findPropertyAliases

    public List<PropertyName> findPropertyAliases(Annotated ann)

Method called to find if given property has alias(es) defined.

Returns:
  `null` if member has no information; otherwise a `List` (possibly empty) of aliases to use.
Since:
  2.9

#### findPropertyAccess

    public com.fasterxml.jackson.annotation.JsonProperty.Access findPropertyAccess(Annotated ann)

Method for finding optional access definition for a property, annotated on one of its accessors. If a definition for read-only, write-only or read-write cases, visibility rules may be modified. Note, however, that even more specific annotations (like one for ignoring specific accessor) may further override behavior of the access definition.

Since:
  2.6

#### resolveSetterConflict

    public AnnotatedMethod resolveSetterConflict(MapperConfig<?> config,
                                                 AnnotatedMethod setter1,
                                                 AnnotatedMethod setter2)

Method called in cases where a class has two methods eligible to be used for the same logical property, and default logic is not enough to figure out clear precedence. Introspector may try to choose one to use; or, if unable, return `null` to indicate it cannot resolve the problem.

Since:
  2.7

#### findRenameByField

    public PropertyName findRenameByField(MapperConfig<?> config,
                                          AnnotatedField f,
                                          PropertyName implName)

Method called on fields that are eligible candidates for properties (that is, non-static member fields), but not necessarily selected (may or may not be visible), to let fields affect name linking. Call will be made after finding implicit name (which by default is just name of the field, but may be overridden by introspector), but before discovering other accessors. If non-null name returned, it is to be used to find other accessors (getters, setters, creator parameters) and replace their implicit names with that of field's implicit name (assuming they differ).

Specific example (and initial use case is for support Kotlin's "is getter" matching (see Kotling Interop for details), in which field like '`isOpen`' would have implicit name of "isOpen", match getter `getOpen()` and setter `setOpen(boolean)`, but use logical external name of "isOpen" (and not implicit name of getter/setter, "open"!). To achieve this, field implicit name needs to remain "isOpen" but this method needs to return name `PropertyName.construct("open")`: doing so will "pull in" getter and/or setter, and rename them as "isOpen".

Parameters:
  `config` - Effective mapper configuration in use
  `f` - Field to check
  `implName` - Implicit name of the field; usually name of field itself but not always, used as the target name for accessors to rename.
Returns:
  Name used to find other accessors to rename, if any; `null` to indicate no renaming
Since:
  2.11

#### findInjectableValueId

    @Deprecated
    public Object findInjectableValueId(AnnotatedMember m)

Deprecated. Since 2.9 Use `findInjectableValue(com.fasterxml.jackson.databind.introspect.AnnotatedMember)` instead

#### findSerializer

    public Object findSerializer(Annotated am)

Method for getting a serializer definition on specified method or field. Type of definition is either instance (of type `JsonSerializer`) or Class (of `Class<JsonSerializer>` implementation subtype); if value of different type is returned, a runtime exception may be thrown by caller.

#### findKeySerializer

    public Object findKeySerializer(Annotated am)

Method for getting a serializer definition for keys of associated `java.util.Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class<JsonSerializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

#### findContentSerializer

    public Object findContentSerializer(Annotated am)

Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class<JsonSerializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

#### findNullSerializer

    public Object findNullSerializer(Annotated am)

Method for getting a serializer definition for serializer to use for nulls (null values) of associated property or type.

Since:
  2.3

#### findSerializationTyping

    public JsonSerialize.Typing findSerializationTyping(Annotated a)

Method for accessing declared typing mode annotated (if any). This is used for type detection, unless more granular settings (such as actual exact type; or serializer to use which means no type information is needed) take precedence.

Returns:
  Typing mode to use, if annotation is found; null otherwise

#### findSerializationConverter

    public Object findSerializationConverter(Annotated a)

Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of serialization. If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used first to convert property value to converter target type, and then serializer for that type is used for actual serialization.

This feature is typically used to convert internal values into types that Jackson can convert.

Note also that this feature does not necessarily work well with polymorphic type handling, or object identity handling; if such features are needed an explicit serializer is usually better way to handle serialization.

Parameters:
  `a` - Annotated property (field, method) or class to check for annotations
Since:
  2.2

#### findSerializationContentConverter

    public Object findSerializationContentConverter(AnnotatedMember a)

Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).

If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used first to convert property value to converter target type, and then serializer for that type is used for actual serialization.

Other notes are same as those for `findSerializationConverter(com.fasterxml.jackson.databind.introspect.Annotated)`

Parameters:
  `a` - Annotated property (field, method) to check.
Since:
  2.2

#### findPropertyInclusion

    public com.fasterxml.jackson.annotation.JsonInclude.Value findPropertyInclusion(Annotated a)

Method for checking inclusion criteria for a type (Class) or property (yes, method name is bit unfortunate -- not just for properties!). In case of class, acts as the default for properties POJO contains; for properties acts as override for class defaults and possible global defaults.

Since:
  2.6

#### refineSerializationType

    public JavaType refineSerializationType(MapperConfig<?> config,
                                            Annotated a,
                                            JavaType baseType)
                                     throws JsonMappingException

Method called to find out possible type refinements to use for deserialization, including not just value itself but key and/or content type, if type has those.

Throws:
  `JsonMappingException`
Since:
  2.7

#### findSerializationPropertyOrder

    public String[] findSerializationPropertyOrder(AnnotatedClass ac)

Method for accessing defined property serialization order (which may be partial). May return null if no ordering is defined.

#### findSerializationSortAlphabetically

    public Boolean findSerializationSortAlphabetically(Annotated ann)

Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered

#### findAndAddVirtualProperties

    public void findAndAddVirtualProperties(MapperConfig<?> config,
                                            AnnotatedClass ac,
                                            List<BeanPropertyWriter> properties)

Method for adding possible virtual properties to be serialized along with regular properties.

Since:
  2.5

#### findNameForSerialization

    public PropertyName findNameForSerialization(Annotated a)

Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for serialization. Should return null if no annotation is found; otherwise a non-null name (possibly `PropertyName.USE_DEFAULT`, which means "use default heuristics").

Parameters:
  `a` - Property accessor to check
Returns:
  Name to use if found; null if not.
Since:
  2.1

#### hasAsKey

    public Boolean hasAsKey(MapperConfig<?> config,
                            Annotated a)

Method for checking whether given method has an annotation that suggests the return value of annotated field or method should be used as "the key" of the object instance; usually serialized as a primitive value such as String or number.

Returns:
  `Boolean.TRUE` if such annotation is found and is not disabled; `Boolean.FALSE` if disabled annotation (block) is found (to indicate accessor is definitely NOT to be used "as value"); or `null` if no information found.
Since:
  2.12

#### hasAsValue

    public Boolean hasAsValue(Annotated a)

Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.

Returns:
  `Boolean.TRUE` if such annotation is found and is not disabled; `Boolean.FALSE` if disabled annotation (block) is found (to indicate accessor is definitely NOT to be used "as value"); or `null` if no information found.
Since:
  2.9

#### hasAnyGetter

    public Boolean hasAnyGetter(Annotated ann)

Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.

Parameters:
  `ann` - Annotated entity to check
Returns:
  True if such annotation is found (and is not disabled), false otherwise
Since:
  2.9

#### findEnumValues

    @Deprecated
    public String[] findEnumValues(Class<?> enumType,
                                               Enum<?>[] enumValues,
                                               String[] names)

Deprecated. Since 2.16
Method for efficiently figuring out which if given set of `Enum` values have explicitly defined name. Method will overwrite entries in incoming `names` array with explicit names found, if any, leaving other entries unmodified.

Parameters:
  `enumType` - Type of Enumeration
  `enumValues` - Values of enumeration
  `names` - Matching declared names of enumeration values (with indexes matching `enumValues` entries)
Returns:
  Array of names to use (possible `names` passed as argument)
Since:
  2.7

#### findEnumValues

    public String[] findEnumValues(MapperConfig<?> config,
                                   AnnotatedClass annotatedClass,
                                   Enum<?>[] enumValues,
                                   String[] names)

Finds the explicitly defined name of the given set of `Enum` values, if any. The method overwrites entries in the incoming `names` array with the explicit names found, if any, leaving other entries unmodified.

Parameters:
  `config` - the mapper configuration to use
  `annotatedClass` - the annotated class for which to find the explicit names
  `enumValues` - the set of `Enum` values to find the explicit names for
  `names` - the matching declared names of enumeration values (with indexes matching `enumValues` entries)
Returns:
  an array of names to use (possibly `names` passed as argument)
Since:
  2.16

#### findEnumAliases

    @Deprecated
    public void findEnumAliases(Class<?> enumType,
                                            Enum<?>[] enumValues,
                                            String[][] aliases)

Deprecated. Since 2.16
Method that is related to `findEnumValues(java.lang.Class<?>, java.lang.Enum<?>[], java.lang.String[])` but is called to check if there are alternative names (aliased) that can be accepted for entries, in addition to primary names introspected earlier. If so, these aliases should be returned in `aliases` `List` passed as argument (and initialized for proper size by caller).

Parameters:
  `enumType` - Type of Enumeration
  `enumValues` - Values of enumeration
  `aliases` - (in/out) Pre-allocated array where aliases found, if any, may be added (in indexes matching those of `enumValues`)
Since:
  2.11

#### findEnumAliases

    public void findEnumAliases(MapperConfig<?> config,
                                AnnotatedClass annotatedClass,
                                Enum<?>[] enumValues,
                                String[][] aliases)

Method that is called to check if there are alternative names (aliases) that can be accepted for entries in addition to primary names that were introspected earlier, related to `findEnumValues(java.lang.Class<?>, java.lang.Enum<?>[], java.lang.String[])`. These aliases should be returned in `String[][] aliases` passed in as argument. The `aliases.length` is expected to match the number of `Enum` values.

Parameters:
  `config` - The configuration of the mapper
  `annotatedClass` - The annotated class of the enumeration type
  `enumValues` - The values of the enumeration
  `aliases` - (in/out) Pre-allocated array where aliases found, if any, may be added (in indexes matching those of `enumValues`)
Since:
  2.16

#### findDefaultEnumValue

    public Enum<?> findDefaultEnumValue(AnnotatedClass ac,
                                        Enum<?>[] enumValues)

Finds the first Enum value that should be considered as default value for unknown Enum values, if present.

Parameters:
  `ac` - The Enum class to scan for the default value.
  `enumValues` - The Enum values of the Enum class.
Returns:
  null if none found or it's not possible to determine one.
Since:
  2.16

#### findDefaultEnumValue

    @Deprecated
    public Enum<?> findDefaultEnumValue(Class<Enum<?>> enumCls)

Deprecated. Since 2.16. Use `findDefaultEnumValue(AnnotatedClass, Enum[])` instead.
Finds the Enum value that should be considered the default value, if possible.

Parameters:
  `enumCls` - The Enum class to scan for the default value
Returns:
  null if none found or it's not possible to determine one
Since:
  2.8

#### findEnumValue

    @Deprecated
    public String findEnumValue(Enum<?> value)

Deprecated. Since 2.8: use `findEnumValues(java.lang.Class<?>, java.lang.Enum<?>[], java.lang.String[])` instead because this method does not properly handle override settings (defaults to `enum.name` without indicating whether that is explicit or not), and is inefficient to call one-by-one.
Method for determining the String value to use for serializing given enumeration entry; used when serializing enumerations as Strings (the standard method).

Parameters:
  `value` - Enum value to introspect
Returns:
  Serialized enum value.

#### hasAsValueAnnotation

    @Deprecated
    public boolean hasAsValueAnnotation(AnnotatedMethod am)

Deprecated. Since 2.9 Use `hasAsValue(Annotated)` instead.

Parameters:
  `am` - Annotated method to check

#### hasAnyGetterAnnotation

    @Deprecated
    public boolean hasAnyGetterAnnotation(AnnotatedMethod am)

Deprecated. Since 2.9 Use `hasAnyGetter(com.fasterxml.jackson.databind.introspect.Annotated)` instead

Parameters:
  `am` - Annotated method to check

#### findDeserializer

    public Object findDeserializer(Annotated am)

Method for getting a deserializer definition on specified method or field. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class&<JsonDeserializer>`); type is returned, a runtime exception may be thrown by caller.

#### findKeyDeserializer

    public Object findKeyDeserializer(Annotated am)

Method for getting a deserializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class<JsonDeserializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

#### findContentDeserializer

    public Object findContentDeserializer(Annotated am)

Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class<JsonDeserializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

#### findDeserializationConverter

    public Object findDeserializationConverter(Annotated a)

Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of deserialization. If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used after Jackson has deserializer data into intermediate type (Converter input type), and Converter needs to convert this into its target type to be set as property value.

This feature is typically used to convert intermediate Jackson types (that default deserializers can produce) into custom type instances.

Note also that this feature does not necessarily work well with polymorphic type handling, or object identity handling; if such features are needed an explicit deserializer is usually better way to handle deserialization.

Parameters:
  `a` - Annotated property (field, method) or class to check for annotations
Since:
  2.2

#### findDeserializationContentConverter

    public Object findDeserializationContentConverter(AnnotatedMember a)

Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).

If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used after Jackson has deserializer data into intermediate type (Converter input type), and Converter needs to convert this into its target type to be set as property value.

Other notes are same as those for `findDeserializationConverter(com.fasterxml.jackson.databind.introspect.Annotated)`

Parameters:
  `a` - Annotated property (field, method) to check.
Since:
  2.2

#### refineDeserializationType

    public JavaType refineDeserializationType(MapperConfig<?> config,
                                              Annotated a,
                                              JavaType baseType)
                                       throws JsonMappingException

Method called to find out possible type refinements to use for deserialization.

Throws:
  `JsonMappingException`
Since:
  2.7

#### findValueInstantiator

    public Object findValueInstantiator(AnnotatedClass ac)

Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Either `ValueInstantiator` instance to use, or `Class` of one to create; or `null` if no annotations found to indicate custom value instantiator.

#### findPOJOBuilder

    public Class<?> findPOJOBuilder(AnnotatedClass ac)

Method for finding Builder object to use for constructing value instance and binding data (sort of combining value instantiators that can construct, and deserializers that can bind data).

Note that unlike accessors for some helper Objects, this method does not allow returning instances: the reason is that builders have state, and a separate instance needs to be created for each deserialization call.

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Builder class to use, if annotation found; `null` if not.
Since:
  2.0

#### findPOJOBuilderConfig

    public JsonPOJOBuilder.Value findPOJOBuilderConfig(AnnotatedClass ac)

Parameters:
  `ac` - Annotated class to introspect
Returns:
  Builder settings to use, if any found; `null` if not.
Since:
  2.0

#### findNameForDeserialization

    public PropertyName findNameForDeserialization(Annotated ann)

Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for deserialization (reading JSON into POJOs). Should return null if no annotation is found; otherwise a non-null name (possibly `PropertyName.USE_DEFAULT`, which means "use default heuristics").

Parameters:
  `ann` - Annotated entity to check
Returns:
  Name to use if found; `null` if not.
Since:
  2.1

#### hasAnySetter

    public Boolean hasAnySetter(Annotated ann)

Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.

Parameters:
  `ann` - Annotated entity to check
Returns:
  `Boolean.TRUE` or `Boolean.FALSE` if explicit "any setter" marker found; `null` otherwise.
Since:
  2.9

#### findSetterInfo

    public com.fasterxml.jackson.annotation.JsonSetter.Value findSetterInfo(Annotated ann)

Method for finding possible settings for property, given annotations on an accessor.

Parameters:
  `ann` - Annotated entity to check
Returns:
  Setter info value found, if any; `JsonSetter.Value.empty()` if none (should not return `null`)
Since:
  2.9

#### findMergeInfo

    public Boolean findMergeInfo(Annotated ann)

Method for finding merge settings for property, if any.

Parameters:
  `ann` - Annotated entity to check
Returns:
  `Boolean.TRUE` or `Boolean.FALSE` if explicit merge enable/disable found; `null` otherwise.
Since:
  2.9

#### findCreatorAnnotation

    public com.fasterxml.jackson.annotation.JsonCreator.Mode findCreatorAnnotation(MapperConfig<?> config,
                                                                                   Annotated ann)

Method called to check whether potential Creator (constructor or static factory method) has explicit annotation to indicate it as actual Creator; and if so, which `JsonCreator.Mode` to use.

NOTE: caller needs to consider possibility of both `null` (no annotation found) and `JsonCreator.Mode.DISABLED` (annotation found, but disabled); latter is necessary as marker in case multiple introspectors are chained, as well as possibly as when using mix-in annotations.

Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `ann` - Annotated accessor (usually constructor or static method) to check
Returns:
  Creator mode found, if any; `null` if none
Since:
  2.9

#### hasCreatorAnnotation

    @Deprecated
    public boolean hasCreatorAnnotation(Annotated ann)

Deprecated. Since 2.9 use `findCreatorAnnotation(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead.
Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.

Parameters:
  `ann` - Annotated entity to check
Returns:
  True if such annotation is found (and is not disabled), false otherwise

#### findCreatorBinding

    @Deprecated
    public com.fasterxml.jackson.annotation.JsonCreator.Mode findCreatorBinding(Annotated ann)

Deprecated. Since 2.9 use `findCreatorAnnotation(com.fasterxml.jackson.databind.cfg.MapperConfig<?>, com.fasterxml.jackson.databind.introspect.Annotated)` instead.
Method for finding indication of creator binding mode for a creator (something for which `hasCreatorAnnotation(com.fasterxml.jackson.databind.introspect.Annotated)` returns true), for cases where there may be ambiguity (currently: single-argument creator with implicit but no explicit name for the argument).

Parameters:
  `ann` - Annotated entity to check
Returns:
  Creator mode found, if any; `null` if none
Since:
  2.5

#### hasAnySetterAnnotation

    @Deprecated
    public boolean hasAnySetterAnnotation(AnnotatedMethod am)

Deprecated. Since 2.9 use `hasAnySetter(com.fasterxml.jackson.databind.introspect.Annotated)` instead.

Parameters:
  `am` - Annotated method to check
Returns:
  `true` if "any-setter" annotation was found; `false` otherwise

#### _findAnnotation

    protected <A extends Annotation> A _findAnnotation(Annotated ann,
                                                       Class<A> annoClass)

Method that should be used by sub-classes for ALL annotation access; overridable so that sub-classes may, if they choose to, mangle actual access to block access ("hide" annotations) or perhaps change it.

Default implementation is simply: `return annotated.getAnnotation(annoClass);`

Type Parameters:
  `A` - Annotation type being checked
Parameters:
  `ann` - Annotated entity to check for specified annotation
  `annoClass` - Type of annotation to find
Returns:
  Value of given annotation (as per `annoClass`), if entity has one; `null` otherwise
Since:
  2.5

#### _hasAnnotation

    protected boolean _hasAnnotation(Annotated ann,
                                     Class<? extends Annotation> annoClass)

Method that should be used by sub-classes for ALL annotation existence access; overridable so that sub-classes may, if they choose to, mangle actual access to block access ("hide" annotations) or perhaps change value seen.

Default implementation is simply: `return annotated.hasAnnotation(annoClass);`

Parameters:
  `ann` - Annotated entity to check for specified annotation
  `annoClass` - Type of annotation to find
Returns:
  `true` if specified annotation exists in given entity; `false` if not
Since:
  2.5

#### _hasOneOf

    protected boolean _hasOneOf(Annotated ann,
                                Class<? extends Annotation>[] annoClasses)

Alternative lookup method that is used to see if annotation has at least one of annotations of types listed in second argument.

Parameters:
  `ann` - Annotated entity to check for specified annotation
  `annoClasses` - Types of annotation to find
Returns:
  `true` if at least one of specified annotation exists in given entity; `false` otherwise
Since:
  2.7